/* 페이징 관련 변수 */
let companyTotalCount   = 0;
let companyTotalPages   = 0;

/*aggird*/
let companyAgGridData = [];

let companySelectId = "";

/****************************************************************************
* 거래처관리 정보 리스트 조회
****************************************************************************/
function fn_selectListCompanyJson(){
	let formData = new FormData();
	formData.append("menuClass", menuClass);
	formData.append("companySearchKeywordParam", companySearchKeywordParam);
	formData.append("companySort", companySort);
	formData.append("companyDir", companyDir);
	formData.append("companyStart", companyStart);
	formData.append("companyLimit", companyLimit);

	$.ajax({
		url: encodeURI('/webcompany/selectListCompany.do'),
		data: formData,
		dataType: "json",
		processData: false,
		contentType: false,
		type: 'POST',
		async: true,
		success: function(data){
			if('0'==data.msgCode){
				// 페이징 처리
				companyTotalCount  = data.totalCount;
				//$("#txt_companyTotalCount").text(companyTotalCount);
				
				companyTotalPages = Math.ceil(companyTotalCount/companyLimit);
				
				// 리스트 조회
				companyAgGridData = data.rows;
				companyGridOptions.api.setRowData(companyAgGridData);

				if(0<data.rows.length){
					//페이징 처리
					window.pagObj = $('#companyPagination').twbsPagination({
						startPage    : ((companyStart/companyLimit)+1),
						totalPages   : (companyTotalPages==0)?1:companyTotalPages,
						visiblePages : 10,
						initiateStartPageClick: false,
						prev         : '<img src="/image/web/page_navigation_arrow.svg" alt="prev">',
						next         : '<img src="/image/web/page_navigation_arrow.svg" alt="next">',
						first        : '',
						last         : '',
						onPageClick: function (event, page) {
							fn_companyPagination(page);
						}
					}).on('page', function (event, page) {
						//console.info(page + ' (from event listening)');
					});
				}
				else{
					
				}
			}
			else{
				modalEvent.danger("조회 오류", data.msgDesc);
			}
		},
		error : function(xhr, status, error) {
			modalEvent.danger("조회 오류", "조회 중 오류가 발생하였습니다. 잠시후 다시시도하십시오.");
		},
		beforeSend:function(){
			// 로딩열기
			companyGridOptions.api.showLoadingOverlay();
		},
		complete:function(){
			
		}
	});
}

/****************************************************************************
* 검색하기
****************************************************************************/
function fn_companySearch(param){
	if("A"!=param && "Y"!=selectUseYn){
		modalEvent.warning("", "조회 권한이 없습니다.");
		return false;
	}
	
	fn_companyPaginReset();
	
	companySearchKeywordParam = $("#companySearchKeyword").val();

	fn_selectListCompanyJson();
}


/****************************************************************************
* 초기화하기
****************************************************************************/
function fn_companyReset(){
	$("#companySearchKeyword").val("");

	fn_companySearch();
}

/****************************************************************************
* 페이징 처리
****************************************************************************/
function fn_companyPagination(param){
	companyStart = (parseInt(param)-1)*companyLimit;
	
	fn_selectListCompanyJson();
}

/****************************************************************************
* 페이징 리셋
****************************************************************************/
function fn_companyPaginReset(){
	companySearchKeywordParam = '';

	companyStart        = 0;
	companyLimit        = 100;
	companyTotalCount   = 0;
	companyTotalPages   = 0;
	
	//페이징 초기화
	if($("#companyPagination").data("twbs-pagination")){
		$("#companyPagination").twbsPagination("destroy");
	}
}

/****************************************************************************
* 거래처관리 삭제
****************************************************************************/
function fn_deleteCompany(){
	if("Y"!=deleteUseYn){
		modalEvent.warning("", "삭제 권한이 없습니다.");
		return false;
	}
	
	if(!companySelectId){
		modalEvent.warning("", "삭제할 대상을 선택하세요.");
		return false;
	}

	modalEvent.info("삭제", "선택한 거래처관리 정보를 삭제하시겠습니까?", function(){
		let formData = new FormData();
		formData.append("menuClass", menuClass);
		formData.append("selectId", companySelectId);

		$.ajax({
			url: encodeURI('/webcompany/deleteCompany.do'),
			data: formData,
			dataType: "json",
			processData: false,
			contentType: false,
			type: 'POST',
			async: true,
			success: function(data){
				if('0'==data.msgCode){
					modalEvent.success("삭제 성공", data.msgDesc, function(){
						fn_companyOk();
					});
				}
				else{
					modalEvent.danger("삭제 오류", data.msgDesc);
				}
			},
			error : function(xhr, status, error) {
				modalEvent.danger("삭제 오류", "삭제 중 오류가 발생하였습니다. 잠시후 다시시도하십시오.");
			},
			beforeSend:function(){
				
			},
			complete:function(){
				
			}
		});
	});
}

/****************************************************************************
* 검색 엔터 이벤트
****************************************************************************/
function fn_companyEnter(e){
	if(e.which){
		// 파이어폭스
		if(13 == e.which) {
			//로그인 액션 스크립트
			fn_companySearch();
		}
	}
	else{
		// 윈도우, 사파리, 크롬
		if(13 == event.keyCode) {
			//로그인 액션 스크립트
			fn_companySearch();
		}
	}
}

/****************************************************************************
* 완료
****************************************************************************/
function fn_companyOk(){
	fn_companyReset();
}

function fn_insertCompanyPopup(){
	if("Y"!=insertUseYn){
		modalEvent.warning("", "등록 권한이 없습니다.");
		return false;
	}
	
	let reqParam =  {};
	companyInsertModal.popup(function(obj, reqParam) {
		fn_companyOk();
	}, reqParam);
}

/****************************************************************************
* 수정 화면으로 이동.
****************************************************************************/
function fn_updateCompanyIntro(param){
	if("Y"==updateUseYn){
		// 수정가능
		let pagingParam = "?menuClass="+menuClass;
		pagingParam    += "&companySearchKeywordParam="+companySearchKeywordParam;
		pagingParam    += "&companySort="+companySort;
		pagingParam    += "&companyDir="+companyDir;
		pagingParam    += "&companyStart="+companyStart;
		pagingParam    += "&companyLimit="+companyLimit;
		pagingParam    += "&muCompanyId="+param;
		
		fn_leftFormAction("/webcompany/updateCompanyIntro.do"+pagingParam);
	}
	else{
		if("Y"==selectUseYn){
			let reqParam =  {
				"muCompanyId" : param
			};
			// 조회만
			companySelectModal.popup(function(obj, reqParam) {
				fn_companyOk();
			}, reqParam);
		}
		else{
			modalEvent.warning("", "조회 및 수정 권한이 없습니다.");
			return false;
		}
	}
	
}

/****************************************************************************
* 페이지 init
****************************************************************************/
function fn_pageInit(){
	// 초기 페이징 처리
	$("#companySearchKeyword").val(companySearchKeywordParam);
	
	fn_companySearch("A");
}

/****************************************************************************
* 페이지 event
****************************************************************************/
function fn_pageEvent(){
	// 검색 input
	$(document).on('keypress', '#companySearchKeyword', function(e) {
		fn_companyEnter(e);
	});
	
	// 검색 조회 버튼
	$("#btnSarechCompany").click(function () {
		fn_companySearch();
	});
	
	// 근태 관리 - 출퇴/휴무 등록 버튼
	$("#btnInsertCompany").click(function () {
		fn_insertCompanyPopup();
	});
}

$(function(){
	// 페이지 init
	fn_pageInit();
	
	// 페이지 event
	fn_pageEvent();
});

let companyColumnDefs = [
	/*{field: "checkbox", headerName:"", minWidth:55, maxWidth:55, headerCheckboxSelection: true, checkboxSelection: true},*/
	/* {field: "rowNum", headerName:"번호", minWidth:80,maxWidth:80, sortable: false}, */
	{field: "rowNum", headerName:"번호", minWidth:60,sortable: false, cellStyle:{textAlign: 'center'}},
	{field: "companyName", headerName:"거래처명", minWidth:250, maxWidth:250, cellStyle:{cursor: 'pointer', color:'#3985EA'}},
	{field: "businessNumber", headerName:"사업자번호",minWidth:120, maxWidth:120},
	{field: "userName", headerName:"담당자",minWidth:120, maxWidth:120},
	{field: "phoneNumber", headerName:"연락처",minWidth:120, maxWidth:120},
	{field: "productName", headerName:"품목",minWidth:300},
	{field: "memo", headerName:"메모",minWidth:609}
];

// let the grid know which columns and what data to use
let companyGridOptions = {
	suppressRowTransform: true,
	columnDefs: companyColumnDefs,
	defaultColDef: {		// 리스트 기본 설정
		flex: 1,
		sortable: true,		//정렬 여부
		resizable: true,	//리사이즈
		editable: false,	// 그리드에서 데이터 수정
		cellStyle:{textAlign:'left',fontSize:'14px',padding:'0'},
		//suppressSizeToFit:true,		//자동 맞춤
		//enableRowGroup: true,		// 그룹 묶음
		enablePivot: true,
		enableValue : true
	},
	//suppressMultiSort:true,  //단일솔트 true가 단일, false가 다중 shift + sort 시
	headerHeight : 41, // header 높이
	rowHeight : 41, // row 높이
	rowData : companyAgGridData,
	suppressRowClickSelection : true, // 로우 클릭시 체크박스 선택 true no, false yes
	localeText : {
		noRowsToShow : '조회 결과가 없습니다.'
	}, //데이터 없을 시 나오는 문구
	rowSelection : 'multiple', // row 다중 선택
	debug : false,
	onCellClicked: function(event){ //셀 클릭 이벤트
		/* alert(event.column.colId); */
		if('companyName'==event.column.colId){
			fn_updateCompanyIntro(event.data.muCompanyId);
		}
	},
	onSelectionChanged: function(event){ //체크박스 선택
		let selectRows = [];
		selectRows = event.api.getSelectedRows();
		
		companySelectId = '';
		for(let i=0; i<selectRows.length; i++){
			companySelectId += selectRows[i].muCompanyId + ",";
		}
		companySelectId = companySelectId.substring(0, companySelectId.lastIndexOf(','));
	},
	onSortChanged: function(event){
		 //정렬
		companySort = ''; //기존 정렬 초기화
		let columnArr = event.columnApi.getColumnState();
		if(0<columnArr.length){
			//sort index 순으로 재정렬
			columnArr.sort(function(a,b){
				return a.sortIndex - b.sortIndex;
			});
			
			let nullCnt = 0;
			for(let i=0; i<columnArr.length; i++){
				let gridSortModel = columnArr[i].colId;
				let gridSort = columnArr[i].sort;

				if(gridSort != null){
					companyStart = 0;
					companySort += gridSortModel+' '+ gridSort + ',';
				}
				else{
					nullCnt++;
					
					if(nullCnt == columnArr.length){
						companySort = '';
						companyDir = '';
						companyStart = 0;
					}
				}
			}
		}
		companySort = companySort.substring(0,companySort.lastIndexOf( ",")); //맨끝 콤마 지우기
		
		fn_companySearch();
	}
};

// lookup the container we want the Grid to use
let companyGridDiv = document.querySelector('#companyGrid');

// create the grid passing in the div to use together with the columns & data we want to use
new agGrid.Grid(companyGridDiv, companyGridOptions);